require 'tk'

# Window drawing section.

root = TkRoot.new() { title "BLANKETY BLANK" }
root.geometry('+39+80')

boxes_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x")

file_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx" =>10, "pady" =>5)
file_label = TkLabel.new(file_frame, :text=>"File Name", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

file_text = TkVariable.new
file_entry = TkEntry.new(file_frame, :textvariable=>file_text, "font"=>"arial 10").pack()

file_read_button = TkButton.new(file_frame, :text=>"Read File", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack("pady" => 5)

exit_button = TkButton.new(file_frame, :width=>6, :foreground=>"red", :text=>"Exit", :background=>"lightgrey", "font"=>"arial 10").pack(:pady=>5)

first_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx" =>30, "pady" =>5)
first_button = TkButton.new(first_box_frame, :text=>"First Box", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

first_text_frame = TkFrame.new(first_box_frame).pack("side"=>"top")
first_box_bar_vert = TkScrollbar.new(first_text_frame).pack("side"=>"right", "fill"=>"y")
first_box_text = TkText.new(first_text_frame, "wrap"=>"none", "width"=>15, "height"=>3, "font"=>"arial 10").pack("side"=>"left")
first_box_text.yscrollbar(first_box_bar_vert)

clear_first_button = TkButton.new(first_box_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

last_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx" =>10, "pady" =>5)
last_button = TkButton.new(last_box_frame, :text=>"Last Box", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

last_text_frame = TkFrame.new(last_box_frame).pack("side"=>"top")
last_box_bar_vert = TkScrollbar.new(last_text_frame).pack("side"=>"right", "fill"=>"y")
last_box_text = TkText.new(last_text_frame, "wrap"=>"none", "width"=>15, "height"=>3, "font"=>"arial 10").pack("side"=>"left")
last_box_text.yscrollbar(last_box_bar_vert)

clear_last_button = TkButton.new(last_box_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

exclusion_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx"=>30, "pady"=>5)
exclusion_button = TkButton.new(exclusion_box_frame, :text=>"Exclusion Boxes", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

exclusion_text_frame = TkFrame.new(exclusion_box_frame).pack("side"=>"top")
exclusion_box_bar_vert = TkScrollbar.new(exclusion_text_frame).pack("side"=>"right", "fill"=>"y")
exclusion_box_text = TkText.new(exclusion_text_frame, "wrap"=>"none", "width"=>15, "height"=>6, "font"=>"arial 10").pack("side"=>"left")
exclusion_box_text.yscrollbar(exclusion_box_bar_vert)

clear_exclusion_button = TkButton.new(exclusion_box_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5)

box_list_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("side"=>"left", "padx" =>10, "pady" =>5)
box_list_label = TkLabel.new(box_list_frame, :text=>"Box List", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

box_select_frame = TkFrame.new(box_list_frame).pack("side"=>"bottom", "pady" => 5)
box_select_button = TkButton.new(box_select_frame, :text=>"Select Single", :background=>"lightgrey", :foreground=>"blue", :width=>11, "font"=>"arial 10").pack()

box_list_bar_vertical = TkScrollbar.new(box_list_frame).pack("side"=>"right", "fill"=>"y")
box_list = TkListbox.new(box_list_frame, "background"=>"white", "exportselection" => 0, "width"=>15, "height"=>8, :selectmode=>"extended", "font"=>"arial 10").pack("side"=>"left")
box_list.yscrollbar(box_list_bar_vertical)

style_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x")

list_frame = TkFrame.new(style_frame, :borderwidth=>3, :relief=>:ridge).pack("side"=>"left", "padx" =>10)
style_label = TkLabel.new(list_frame, :text=>"Click On Your Desired BLANKETY BLANK Style", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)
style_label.pack()

style_list = TkListbox.new(list_frame, "background"=>"white", "exportselection" => 0, "width"=>45, "height"=>4, "font"=>"arial 10").pack("side"=>"left")

style_list.insert("end", "Bob version : if ((box1_1 + box1_4).strip.length > 0)")
style_list.insert("end", "April version : if( ( box1_1 + box1_4 ).strip.length == 0 )")
style_list.insert("end", "Harry version : if (not_empty(box1_1,box1_4))")
style_list.insert("end", "Custom : if ( box1_1 < 100.0 ) for example.")

#These set the default style_list selections at startup. Bob version is the default. The indices start at 0.
# Bob version is the default - not need to activate it.
#~ style_list.activate(1)	# April version.
#~ style_list.activate(2)	# Harry version.

style_list.selection_set(0)	# Highlight Bob version.
#~ style_list.selection_set(1)	 # Highlight April version.
#~ style_list.selection_set(2)	 # Highlight Harry version.

multi_frame = TkFrame.new(style_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>:left, :fill=>:y)

multi_label = TkLabel.new(multi_frame, :text=>"Multi Blank Options", :relief=>:sunken, :width=>28, :background=>"lightgrey", "font"=>"arial 10").pack(:side=>:top, :fill=>:x)

multi_left_frame = TkFrame.new(multi_frame, :borderwidth=>1, :relief=>:ridge).pack(:side=>:left, :fill=>:y)
multi_left_label1 = TkLabel.new(multi_left_frame, :text=>"Boxes", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_left_label2 = TkLabel.new(multi_left_frame, :text=>"Left", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_boxes_left_num = TkVariable.new
multi_boxes_left_num_entry = TkEntry.new(multi_left_frame, "textvariable"=>multi_boxes_left_num, "width"=>3, "font"=>"arial 10")
multi_boxes_left_num_entry.pack()
multi_boxes_left_num.value = ""

multi_right_frame = TkFrame.new(multi_frame, :borderwidth=>1, :relief=>:ridge).pack(:side=>:left, :fill=>:y)
multi_right_label1 = TkLabel.new(multi_right_frame, :text=>"Boxes", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_right_label2 = TkLabel.new(multi_right_frame, :text=>"Right", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_boxes_right_num = TkVariable.new
multi_boxes_right_num_entry = TkEntry.new(multi_right_frame, "textvariable"=>multi_boxes_right_num, "width"=>3, "font"=>"arial 10")
multi_boxes_right_num_entry.pack()
multi_boxes_right_num.value = ""

multi_offset_frame = TkFrame.new(multi_frame, :borderwidth=>1, :relief=>:ridge).pack(:side=>:left, :fill=>:y)
multi_offset_label1 = TkLabel.new(multi_offset_frame, :text=>"Box", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_offset_label2 = TkLabel.new(multi_offset_frame, :text=>"Offset", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_boxes_offset_num = TkVariable.new
multi_boxes_offset_num_entry = TkEntry.new(multi_offset_frame, "textvariable"=>multi_boxes_offset_num, "width"=>3, "font"=>"arial 10")
multi_boxes_offset_num_entry.pack()
multi_boxes_offset_num.value = ""

multi_group_frame = TkFrame.new(multi_frame, :borderwidth=>1, :relief=>:ridge).pack(:side=>:left, :fill=>:y)
multi_group_label1 = TkLabel.new(multi_group_frame, :text=>"Group", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_group_label2 = TkLabel.new(multi_group_frame, :text=>"Size", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_boxes_group_num = TkVariable.new
multi_boxes_group_num_entry = TkEntry.new(multi_group_frame, "textvariable"=>multi_boxes_group_num, "width"=>3, "font"=>"arial 10")
multi_boxes_group_num_entry.pack()
multi_boxes_group_num.value = ""

multi_fill_gap_frame = TkFrame.new(multi_frame, :borderwidth=>1, :relief=>:ridge).pack(:side=>:left, :fill=>:y)
multi_fill_gap_label1 = TkLabel.new(multi_fill_gap_frame, :text=>"Fill", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_fill_gap_label2 = TkLabel.new(multi_fill_gap_frame, :text=>"Gaps", :width=>6, "font"=>"arial 10").pack(:side=>:top)
multi_fill_gap_button = TkButton.new(multi_fill_gap_frame, :text=>"OFF", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack()

custom_frame = TkFrame.new(style_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"s", "side"=>"left", "fill"=>"x", :padx=>10)
custom_label = TkLabel.new(custom_frame, :text=>"Custom BLANKETY BLANK Style - Defaults to: if ( )", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack()
custom_label.pack()

custom_bar_horiz = TkScrollbar.new(custom_frame, "orient"=>"hor").pack("side"=>"bottom", "fill"=>"x")
custom_bar_text = TkText.new(custom_frame, "wrap"=>"none", "width"=>20, "height"=>1, "font"=>"arial 10").pack("fill"=>"x", "expand"=>true)
custom_bar_text.xscrollbar(custom_bar_horiz)

blank_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x")

s_blank_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "padx"=>10, "pady"=>5)
s_blank_button = TkButton.new(s_blank_button_frame, "width"=>12, :background=>"lightgrey", :text=>"Single Blank", :foreground=>"blue", "font"=>"arial 10").pack()

m_blank_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "pady"=>5)
m_blank_button = TkButton.new(m_blank_button_frame, "width"=>12, :background=>"lightgrey", :text=>"Multi Blank", :foreground=>"blue", "font"=>"arial 10").pack()

r_blank_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "padx"=>10, "pady"=>5)
r_blank_button = TkButton.new(r_blank_button_frame, "width"=>12, :background=>"lightgrey", :text=>"Reverse Blank", :foreground=>"blue", "font"=>"arial 10").pack()

clear_input_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "pady"=>5)
clear_input_button = TkButton.new(clear_input_button_frame, "width"=>12, :background=>"lightgrey", :text=> "Delete Code", :foreground=>"blue", "font"=>"arial 10").pack()

get_boxes_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "padx"=>10, "pady"=>5)
get_boxes_button = TkButton.new(get_boxes_button_frame, "width"=>12, :background=>"lightgrey", :text=>"Create Box List", :foreground=>"blue", "font"=>"arial 10").pack()

delete_box_list_button_frame = TkFrame.new(blank_frame).pack("side"=>"left", "pady"=>5)
delete_box_list_button = TkButton.new(delete_box_list_button_frame, "width"=>12, :background=>"lightgrey", :text=>"Delete Box List", :foreground=>"blue", "font"=>"arial 10").pack()

input_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"both", "expand"=>true)

in_text_frame = TkFrame.new(input_frame).pack("side"=>"left", "fill"=>"both", "padx"=>10, "expand"=>true)
#~ in_text_bar_horiz = TkScrollbar.new(in_text_frame, 'orient'=>'hor').pack('side'=>'bottom', 'fill'=>'x')
in_text_bar_vert = TkScrollbar.new(in_text_frame).pack("side"=>"right", "fill"=>"y")
in_text = TkText.new(in_text_frame, "width"=>113, "height"=>12, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)

#~ in_text.xscrollbar(in_text_bar_horiz)
in_text.yscrollbar(in_text_bar_vert)

in_text.focus

output_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"both", "expand"=>true)

output_label_frame = TkFrame.new(output_frame).pack("side"=>"top")
output_label = TkLabel.new(output_label_frame, :text=>"Code Converted To BLANKETY BLANK Form - NOTE: ' Ctrl-/ ' selects all text.", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack()

out_text_frame = TkFrame.new(output_frame).pack("side"=>"left", "padx" => 10, "fill"=>"both", "expand"=>true)
#~ out_text_bar_horiz = TkScrollbar.new(out_text_frame, 'orient'=>'hor').pack('side'=>'bottom', 'fill'=>'x')
out_text_bar_vert = TkScrollbar.new(out_text_frame).pack("side"=>"right", "fill"=>"y")
out_text = TkText.new(out_text_frame, "width"=>113, "height"=>12, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)

#~ out_text.xscrollbar(out_text_bar_horiz)
out_text.yscrollbar(out_text_bar_vert)

bottom_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x", "pady" => 5)

# Action section.

box_array = Array.new

file_read_button.bind("Button-1") {
  
	src_file_name = file_text.to_s
	src_path = "//Pdc/Folders/FormsProgramming/2005/"
	source = src_path + src_file_name
	
	File.open(source, "r") do |src_file|

		box_list.delete(0, box_list.index('end'))
		box_array.clear

		while ((line = src_file.gets) and (line !~ /\*+\s*Profile Classes\s*\*+/))
			if (line =~ /(\Abox\d+_\d+)/) then box_array.insert(-1, $1) end
		end

		box_array.each { |x| box_list.insert("end", x) }
	end

	# Select (show highlighting) first list element.
	box_list.selection_set(0)
}

first_button.bind("Button-1") {
	#~ box_text = box_list.get("active")
	#~ first_box_text.insert("end", box_text + "\n") if (!box_text.empty?)
	box_indices_array = Array.new
	first_box_array = Array.new

	first_box_array = first_box_text.get("1.0", "end").scan(/box\d+_\d+/)

	box_indices_array = box_list.curselection

	box_indices_array.each { |x|
		box = box_list.get(x)
		first_box_text.insert("end", box + "\n") unless first_box_array.include?(box)
	}

	# Now sort the list and redisplay it.
	first_box_array.clear
	first_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		first_box_array.push([$2.to_i,$4.to_i])
	}

	first_box_array.sort!
	first_box_text.delete("1.0", "end")

	first_box_array.each_index { |index|
		first_box_text.insert("end", "box#{first_box_array[index][0]}_#{first_box_array[index][1]}\n")
	}
}

last_button.bind("Button-1") {
	#~ box_text = box_list.get("active")
	#~ last_box_text.insert("end", box_text + "\n") if (!box_text.empty?)
	box_indices_array = Array.new
	last_box_array = Array.new

	last_box_array = last_box_text.get("1.0", "end").scan(/box\d+_\d+/)

	box_indices_array = box_list.curselection

	box_indices_array.each { |x|
		box = box_list.get(x)
		last_box_text.insert("end", box + "\n") unless last_box_array.include?(box)
	}

	# Now sort the list and redisplay it.
	last_box_array.clear
	last_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		last_box_array.push([$2.to_i,$4.to_i])
	}

	last_box_array.sort!
	last_box_text.delete("1.0", "end")

	last_box_array.each_index { |index|
		last_box_text.insert("end", "box#{last_box_array[index][0]}_#{last_box_array[index][1]}\n")
	}
}

exclusion_button.bind("Button-1") {
	#~ box_text = box_list.get("active")
	#~ exclusion_box_text.insert("end", box_text + "\n") if (!box_text.empty?)
	box_indices_array = Array.new
	exclusion_box_array = Array.new

	exclusion_box_array = exclusion_box_text.get("1.0", "end").scan(/box\d+_\d+/)

	box_indices_array = box_list.curselection

	box_indices_array.each { |x|
		box = box_list.get(x)
		exclusion_box_text.insert("end", box + "\n") unless exclusion_box_array.include?(box)
	}

	# Now sort the list and redisplay it.
	exclusion_box_array.clear
	exclusion_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		exclusion_box_array.push([$2.to_i,$4.to_i])
	}

	exclusion_box_array.sort!
	exclusion_box_text.delete("1.0", "end")

	exclusion_box_array.each_index { |index|
		exclusion_box_text.insert("end", "box#{exclusion_box_array[index][0]}_#{exclusion_box_array[index][1]}\n")
	}
}

box_select_button.bind("Button-1") {

	# Determine the current selectmode configuration, it will be either "extended", one or
	# more contiguous items selectable at a time, or "multiple", where more than one 
	# non-contiguous items selectable at a time. Switch configuration between the two: 
	# "browse" or "multiple".
	case box_list.cget("selectmode")

		when "extended"

			box_list.configure("selectmode", "multiple")
			box_select_button.configure("text", "Select Multiple")

		when "multiple"

			# User can select (highlight) multiple list elements at once.
			box_list.configure("selectmode", "extended")
			box_select_button.configure("text", "Select Single")

			# Clear all selected elements, then select (highlight) the last element selected,
			# which is the currently 'active' element - the last one clicked on.
			box_list.selection_clear(0, "end")
			box_list.selection_set(box_list.index("active"))
	end
}

multi_fill_gap_button.bind("Button-1") {

	# User can fill box numbering gaps in the list of boxes that comprise the if ( ) statement for blanking.
	#
	case multi_fill_gap_button.cget("text")

		when "OFF" then multi_fill_gap_button.configure("text", "ON")
		when "ON" then multi_fill_gap_button.configure("text", "OFF")
	end
}

clear_first_button.bind("Button-1") { first_box_text.delete("1.0", "end") }

clear_last_button.bind("Button-1") { last_box_text.delete("1.0", "end") }

clear_exclusion_button.bind("Button-1") { exclusion_box_text.delete("1.0", "end") }

clear_input_button.bind("Button-1") {
	in_text.delete("1.0", "end")

	# Also default to a "clean state" - ready for the next blanking episode.
	box_list.delete(0, "end")
	exclusion_box_text.delete("1.0", "end")
	first_box_text.delete("1.0", "end")
	last_box_text.delete("1.0", "end")

	# Set the focus to the output text window, and put the cursor at the first char on line one.
	in_text.focus
	in_text.mark_set('insert', '1.0')
	}

exit_button.bind("Button-1") { exit(0) }

s_blank_button.bind("Button-1") {
	blank_button("single", out_text, in_text, first_box_text, last_box_text, exclusion_box_text, custom_bar_text, style_list,multi_boxes_left_num.value.to_i, multi_boxes_right_num.value.to_i, multi_boxes_offset_num.value.to_i, multi_boxes_group_num.value.to_i, multi_fill_gap_button)
	}

m_blank_button.bind("Button-1") {
	blank_button("multiple", out_text, in_text, first_box_text, last_box_text, exclusion_box_text, custom_bar_text, style_list,multi_boxes_left_num.value.to_i, multi_boxes_right_num.value.to_i, multi_boxes_offset_num.value.to_i, multi_boxes_group_num.value.to_i, multi_fill_gap_button)
	}

r_blank_button.bind("Button-1") {
	reverse_blank_button(out_text, in_text, first_box_text, last_box_text, exclusion_box_text, custom_bar_text, style_list,multi_boxes_left_num.value.to_i, multi_boxes_right_num.value.to_i, multi_boxes_offset_num.value.to_i, multi_boxes_group_num.value.to_i, multi_fill_gap_button)
	}

#
# This will reverse the blanked code to the original form.
#
def reverse_blank_button(out_text, in_text, first_box_text, last_box_text, exclusion_box_text, custom_bar_text, style_list, left_num, right_num, offset_num, group_num, multi_fill_gap_button)

	box_array = Array.new
	code_array = Array.new
	input_array = Array.new
	temp_array = Array.new
	print_array = Array.new
	blank_array = Array.new
	comment_array = Array.new

	# Clear the output area.
	out_text.delete("1.0", "end")

	#
	# input_array is set via splitting the supplied code at the newline character, each array element is a line of data.
	#
	input_array = in_text.get("1.0", "end").split(/\n/)

	return if (input_array.length == 0)

	#
	# Process the input_array by looking for a blankety-blank pattern, or patterns in the case of a multi-blank situation.
	#
	process_code = 0
	reverse_code = 0
	end_cnt = 0

	process_print = false
	process_blank = false
	check_for_end_exp = false

	pattern_string = ""

	input_array.each { |code_line|
#~ out_text.insert("end", "At top - code_line = #{code_line}\n")
#~ out_text.insert("end", "At top - pattern_string = #{pattern_string}\n")

		#
		# Look for the blankety-blank pattern(s) - April/Bob/Harry/Custom.
		#
		# An 'if' may or may not be the start of a blankety blank pattern, we start by assuming it is, but we also keep
		# a copy of each code line in case it turns out not to be a blankety blank pattern, in which case we will turn off the
		# pattern recognition flag and output the previously copied code as it was inputted.
		#
		# For blankety blank patterns in process:
		#
		# We will skip blank lines (new line char is stripped, so a blank line will have 0 length in the input_array), we will
		# oversee the line spacing when we output the reversed code.
		#
		if (!pattern_string.empty?)
			temp_array.push(code_line)
			next if (code_line.strip.length == 0)
		end

		case code_line.strip

			when (/\A\s*if(\s+|\()/)

				#
				# NOTE: An 'if' statement - could have nothing between the parens (empty custom blanking).
				# ALSO: This could be the start of a multi-blankety blank component, or a stand-alone blankety blank
				# pattern.
				#
				if (pattern_string.empty?)

					temp_array.push(code_line)
					pattern_string = "if"

				elsif ((pattern_string == "if blank else") or (pattern_string == "if"))

					#
					# This 'if' is in the code section, it is not a blankety blank 'if'.
					#
					end_cnt += 1

					#
					# First get any comments since we saw the 'initial if'.
					#
					if (pattern_string == "if")
						comment_array.each { |comment|
							code_array.push(comment)
						}
					end

					code_array.push(code_line.sub(/\t/,''))
					pattern_string += " code"

				elsif ((pattern_string == "if blank else code") or (pattern_string == "if code"))
					end_cnt += 1
					code_array.push(code_line.sub(/\t/,''))
				else
					#
					# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
					#
					process_code = 1
				end

			when (/\A\s*else\z/)

				#
				# We need to be careful here, as an 'else' could go with a code section 'if', or be the 'else'
				# that goes with the blankety blank format.
				#
				if (pattern_string == "if blank")
					pattern_string += " else" 
				elsif (pattern_string == "if code")
					if (end_cnt > 0)
						code_array.push(code_line.sub(/\t/,''))
					else
						pattern_string += " else" 
					end
				elsif (pattern_string == "if blank else code")
					if (end_cnt > 0)
						code_array.push(code_line.sub(/\t/,''))
					else
						#
						# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
						#
						process_code = 1
					end
				else
					#
					# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
					#
					process_code = 1
				end

			when (/\A\s*end\z/)

				#
				# We need to be careful here, as an 'end' could go with a code section 'if', or be the 'end'
				# that goes with the blankety blank format, or is an 'end' to a 'case', 'while', 'until', 'for',
				# 'unless', or 'loop do' expression (yikes !).
				#
				if (pattern_string == "if code else blank")
					pattern_string += " end" 
				elsif (pattern_string == "if blank else code")
					if (end_cnt > 0)
						code_array.push(code_line.sub(/\t/,''))
						end_cnt -= 1
					else
						pattern_string += " end" 
					end
				elsif (pattern_string == "if code")
					if (end_cnt > 0)
						code_array.push(code_line.sub(/\t/,''))
						end_cnt -= 1
					else
						#
						# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
						#
						process_code = 1
					end
				else
					#
					# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
					#
					process_code = 1
				end

			when (/(\A\s*print\s*')(box)(\d+)(_)(\d+)(',\s*box\d+_\d+\z)/)
#~ out_text.insert("end", "a print: $3 = #{$3}, $5 = #{$5}\n")
#~ out_text.insert("end", "a print: pattern_string = #{pattern_string}\n")

				#
				# The 'print' section comes at the very end of a properly formed blankety blank formation.
				# If this is a blankety blank print, check to see if this is the end of the pattern by comparing to the
				# blanked boxes array.
				#
				if ((pattern_string == "if blank else code end") or (pattern_string == "if code else blank end"))
					pattern_string += " print"
					process_print = true

				elsif ((pattern_string == "if blank else code end print") or (pattern_string == "if code else blank end print"))

					process_print = true

				else
					#
					# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
					#
					process_code = 1
				end

				if (process_print)

					#
					# This print statement is a blankety blank print (so far), check to see if we are done with
					# the pattern.
					#
					print_array.push([$3.to_i,$5.to_i])
					print_array.sort!
#~ out_text.insert("end", "print_array.push([#{$3},#{$5}])\n")

					if (blank_array.eql?(print_array))

						#
						# Done with the current blankety blank pattern.
						#
						process_code = 2
					end

					process_print = false
				end

			when (/(\A\s*)(box)(\d+)(_)(\d+)(\s*=\s*''\z)/)

				#
				# A box is blanked - it is conceivable that this could be a valid code section component.
				# If the very first line in the blankety blank code section is a blank assignment to a box,
				# this will be construed as the start of the blankety blank blank section, so to get around
				# this 'mode switch' the user can make this line a comment and it will be properly treated
				# as a code section component.
				#
				if ((pattern_string == "if") or (pattern_string == "if code else"))
					pattern_string += " blank"
					process_blank = true
				elsif ((pattern_string == "if blank") or (pattern_string == "if code else blank"))
					process_blank = true
				elsif ((pattern_string == "if code") or (pattern_string == "if blank else code"))
					code_array.push(code_line.sub(/\t/,''))
				else
					#
					# Not a blankety blank pattern - output the temp array and reset the pattern string to empty.
					#
					process_code = 1
				end

				if (process_blank)
					blank_array.push([$3.to_i,$5.to_i])
					blank_array.sort!
					process_blank = false
				end

			when (/\A\s*#/)

				#
				# A comment - ignore comments in blankety-blank blank and print sections.
				#
				case pattern_string

					when /\Aif\z/

						#
						# Remember the comment, use it if we move into a code section - we do not yet know
						# for sure.
						#
						comment_array.push(code_line.sub(/\t/,''))

					when /\Aif blank\z|\Aif code else\z|\Aif code else blank\z|\Aif blank else code end\z|\Aif blank else code end print\z|\Aif code else blank end\z|\Aif code else blank end print\z/

						#
						# Ignore the comment.
						#

					when /\Aif code\z|\Aif blank else\z|\Aif blank else code\z/

						#
						# Process the comment - switch to code mode if appropriate.
						#
						code_array.push(code_line.sub(/\t/,''))
						pattern_string += " code" if (pattern_string == "if blank else")

					else
						#
						# Not a blankety blank pattern - output the temp array and reset the pattern string
						# to empty.
						#
						process_code = 1
				end

			else

				#
				# Something other than an 'if/else/end/print/blank/comment' - defaults to a code section component
				# if we are processing a blankety blank component, else, we just output whatever it is and go to the
				# next index.
				#
				case pattern_string

					when /\Aif code\z|\Aif blank else code\z/

						code_array.push(code_line.sub(/\t/,''))

						#
						# We just inserted into the code_array, check if we inserted an expression that also
						# uses an 'end' keyword.
						#
						check_for_end_exp = true

					when /\Aif\z|\Aif blank else\z/

						#
						# First get any comments since we saw the 'initial if'.
						#
						if (pattern_string == "if")
							comment_array.each { |comment|
								code_array.push(comment)
							}
						end

						code_array.push(code_line.sub(/\t/,''))

						#
						# We just inserted into the code_array, check if we inserted an expression that also
						# uses an 'end' keyword.
						#
						check_for_end_exp = true

						pattern_string += " code"
#~ out_text.insert("end", "else:   code_line = #{code_line}\n")
#~ out_text.insert("end", "        pattern_string = #{pattern_string}\n")

					else
						#
						# Not a blankety blank pattern - output the temp array and reset the pattern
						# string to empty.
						#
						process_code = 1
				end

				if (check_for_end_exp)

					if (code_line =~ /\A\s*for\s+|\A\s*unless(\s+|\()|\A\s*case(\s+|\()|\A\s*while(\s+|\()|\A\s*until(\s+|\()|\A\s*loop\s+do/)
						end_cnt += 1
					end

					check_for_end_exp = false
				end
		end

		case process_code

			when 1

				#
				# Blankety blank pattern is not "complete", output the temp array if it contains anything, output the
				# current code_line value if we are not working on a pattern (pattern_string being empty, thus code_line
				# value will not be stored in temp_array).
				#
				temp_array.each { |temp_code|

					out_text.insert("end", "#{temp_code}\n")
				}

				out_text.insert("end", "#{code_line}\n") if (pattern_string.empty?)

			when 2
#~ out_text.insert("end", "process_code = #{process_code}\n")

				#
				# We found a complete pattern - Now use the code array to produce the blankety blank reversal output.
				#
				end_cnt = 0
				prev_box = ''

				0.upto(code_array.length - 1) { |index|
			
					out_text.insert("end", "#{code_array[index]}\n")

					case code_array[index]

						when (/(\A\s*)(box)(\d+)(_)(\d+)(\s*(\+?|-?)=.*\z)/)

							#
							# Box assignment - build a list of boxes if we are inside an expression structure that terminates
							# with an 'end' keyword - for example: 'if'/'unless'/'case'/'while'/'until'/'for'/'loop do'.
							#
							box_array.push([$3.to_i,$5.to_i]) if ((!box_array.include?([$3.to_i,$5.to_i])) and (end_cnt > 0))

							this_box = $2+$3+$4+$5

							if (index == code_array.length - 1)

								out_text.insert("end", "print '#{this_box}', #{this_box}\n")

							elsif (code_array[index + 1] =~ /(\A\s*)(box\d+_\d+)(\s*(\+?|-?)=.*\z)/)
								if (end_cnt == 0)
									if (this_box != $2)
										out_text.insert("end", "print '#{this_box}', #{this_box}\n\n")
									end
								end
							else
								out_text.insert("end", "print '#{this_box}', #{this_box}\n") if (end_cnt == 0)
								out_text.insert("end", "\n")
							end

						when (/\A\s*if(\s+|\()|\A\s*for\s+|\A\s*unless(\s+|\()|\A\s*case(\s+|\()|\A\s*while(\s+|\()|\A\s*until(\s+|\()|\A\s*loop\s+do/)

							#
							# An 'if'/'for'/etc.. statement - print boxes at end of outer 'if'/'for'/etc.. statement
							# (may be nesting). A list of all boxes that are assigned to will be built and then used to
							# produce the print statements once the outer 'end' statement is encountered (end_cnt == 0).
							#
							end_cnt += 1
							out_text.insert("end", "\n")

						when (/\A\s*end\z/)

							#
							# Decrement the end_cnt and if equal to zero, output the print box statements.
							#
							end_cnt -= 1 if (end_cnt > 0)

							if (end_cnt == 0)

								out_text.insert("end", "\n")
								box_array.sort!

								box_array.each_index { |i|

									box = "box#{box_array[i][0]}_#{box_array[i][1]}"
									out_text.insert("end", "print '#{box}', #{box}\n")
								}

								#
								# Empty the box_array.
								#
								box_array.clear
							end

							out_text.insert("end", "\n") if (index != code_array.length - 1)

						else
							out_text.insert("end", "\n")
					end
				}
		end
#~ out_text.insert("end", "At bottom - process_code = #{process_code}\n")
#~ out_text.insert("end", "At bottom - pattern_string = #{pattern_string}\n")

		if (process_code > 0)

			#
			# Either we determined that the 'pattern' we were working on turned out not to be a blankety blank
			# pattern, or we just processed a blankety blank pattern. Init to recognise and process the next pattern.
			#
			pattern_string = ''
			temp_array.clear
			blank_array.clear
			print_array.clear
			code_array.clear
			comment_array.clear
			process_code = 0
		end
	}

	#
	# There could possibly be some leftover code in the temp_array.
	#
	temp_array.each { |temp_code|

		out_text.insert("end", "#{temp_code}\n")
	}

	# Set the focus to the output text window, and put the cursor at the first char on line one.
	out_text.focus
	out_text.mark_set('insert', '1.0')
end

def blank_button(mode, out_text, in_text, first_box_text, last_box_text, exclusion_box_text, custom_bar_text, style_list, left_num, right_num, offset_num, group_num, multi_fill_gap_button)

	blank_array = Array.new
	blank_page_num_array = Array.new
	print_array = Array.new
	code_array = Array.new
	first_box_array = Array.new
	last_box_array = Array.new

	input_str = String.new
	box = String.new

	blank_style = 0
	error_code = 0
	group_cnt = 1
	process_box_range = true
	single_blank = (mode == "single")

	# Clear the output area, and check if we can proceed.
	out_text.delete("1.0", "end")

	# Just catching a user goof.
	group_num = 0 if (group_num < 0)

	if (single_blank)

		first_box_array = first_box_text.get("1.0", "end").scan(/box\d+_\d+/)
		last_box_array = last_box_text.get("1.0", "end").scan(/box\d+_\d+/)

		if (first_box_array.length != last_box_array.length)
			process_box_range = false
			error_code = 1
		end
	end

	input_str = in_text.get("1.0", "end").strip

	# Multi-blanking ignores first_box_array and last_box_array.

	if (process_box_range and (input_str.strip.length > 0))

		# fill_gaps_flag == TRUE means that the user wants to fill any numbering gaps in the box numbers in the if (...boxes...) 
		# statement.
		fill_gaps_flag = (multi_fill_gap_button.cget("text") == "ON")

		# Get blank_style. We do not need to process the first,last, and exclusion arrays if custom blanking is selected.

		blank_style = style_list.index("active")

		input_str.each { |code_line|

			if (code_line =~ /(\s*print +')(box)(\d+)(_)(\d+)(', +box\d+_\d+)/)
				blank_page_num_array.push([$3.to_i,$5.to_i]) if (!blank_page_num_array.include?([$3.to_i, $5.to_i]))
			elsif (!code_line.strip.empty?) then code_array.push(code_line)
			else
				if (!single_blank)

					# We are multi-blanking, we need to determine if it is time to do it now, as blank lines are significant.
					if ((group_num == 0) or (group_num == group_cnt))

						# First produce a sorted blank_array and use it to make the print_array - should have done this
						# differently, but time is short and I am tired and it is 'Friday'.
						blank_page_num_array.sort!

						blank_page_num_array.each_index { |index|

							box = "box#{blank_page_num_array[index][0]}_#{blank_page_num_array[index][1]}"
							blank_array.push(box)
							print_array.push("print '#{box}', #{box}")
						}

						do_the_blank_thing(mode, out_text, first_box_array, last_box_array, exclusion_box_text, custom_bar_text, blank_style, left_num, right_num, offset_num, print_array, blank_array, code_array, fill_gaps_flag)

						# Init for next group.
						group_cnt = 1
						print_array.clear
						blank_array.clear
						blank_page_num_array.clear
						code_array.clear
						out_text.insert("end", "\n")
					else
						group_cnt += 1
					end
				end
			end
		}

		# Check for any blanking that needs to be done, if we are single blanking, we will need to do it now.
		if ((print_array.length + blank_array.length + code_array.length) > 0)

			# First produce a sorted blank_array and use it to make the print_array - should have done this
			# differently, but time is short and I am tired and it is 'Friday'.
			blank_page_num_array.sort!

			blank_page_num_array.each_index { |index|

				box = "box#{blank_page_num_array[index][0]}_#{blank_page_num_array[index][1]}"
				blank_array.push(box)
				print_array.push("print '#{box}', #{box}")
			}

			do_the_blank_thing(mode, out_text, first_box_array, last_box_array, exclusion_box_text, custom_bar_text, blank_style, left_num, right_num, offset_num, print_array, blank_array, code_array, fill_gaps_flag)
		end

		# Set the focus to the output text window, and put the cursor at the first char on line one.
		out_text.focus
		out_text.mark_set('insert', '1.0')
	else
		case error_code
			when 1
				out_text.insert("end", "ERROR - NEED THE SAME NUMBER OF 'First' AND 'Last' BOXES\n")
		end
	end
end

def do_the_blank_thing(mode, out_text, first_box_array, last_box_array, exclusion_box_text, custom_bar_text, blank_style, left_num, right_num, offset_num, print_array, blank_array, code_array, fill_gaps_flag)

	exclusion_box_array = Array.new
	page_num_array = Array.new
	gap_array = Array.new

	box = String.new
	box_str = String.new
	custom_blank_str = String.new
	gap_box = String.new

	# box_str will be the string of boxes for the if ( ) statement.
	box_str = ''
	num = start_num = page = gaps_page = gaps_num = 0
	process_box_range = true

	if (blank_style < 3)

		exclusion_box_array = exclusion_box_text.get("1.0", "end").scan(/box\d+_\d+/)

		# EITHER: Check if the first and last box arrays are empty, if so, build box_str from the code_array - the code to
		# blank contains all of the boxes in question, no need for first and last boxes to determine box_str,
		# OR: Check if we are doing a multiple blank, which ignores the first and last box arrays.
		if (((first_box_array.length + last_box_array.length) == 0) or (mode == "multiple"))

			code_array.each { |code_line|
				code_line.scan(/(box)(\d+)(_)(\d+)/) {
			
				if (!(blank_array.include?($1+$2+$3+$4) or exclusion_box_array.include?($1+$2+$3+$4) or page_num_array.include?([$2.to_i,$4.to_i])))
					page_num_array.push([$2.to_i,$4.to_i])
				end
				}
			}

			# Now sort the two-dimensional page_num_array, which will put the boxes in order correctly, note that this
			# is not a string sort, but an integer sort based on page number and box number for each box. A string sort
			# would say that 'box1_1' is greater than 'box10_1'.
			page_num_array.sort!

			# Checking if the user wants to add boxes at either end of box_str. If so, we will add to the top and/or
			#  bottom of page_num_array as long as the new box is not included in the blank_array, exclusion_box_array,
			# or already in the page_num_array (would happen if the user set the offset to 0). Will also check if the
			# user wants to fill any box num gaps in the if ( ) box list.
			if ((page_num_array.length > 0) and (mode == "multiple")  and (offset_num > 0))

				if (left_num > 0)

					start_num = page_num_array[0][1]
					page = page_num_array[0][0]

					1.upto(left_num) { |x|

						num = start_num - x * offset_num

						if (num > 0)

							if (!(blank_array.include?("box"+page.to_s+"_"+num.to_s) or exclusion_box_array.include?("box"+page.to_s+"_"+num.to_s) or page_num_array.include?([page,num])))

								page_num_array.insert(0, [page,num])
							end
						end
					}
				end

				if (right_num > 0)

					start_num = page_num_array[page_num_array.length - 1][1]
					page = page_num_array[page_num_array.length - 1][0]

					1.upto(right_num) { |x|

						num = start_num + x * offset_num

						if (!(blank_array.include?("box"+page.to_s+"_"+num.to_s) or exclusion_box_array.include?("box"+page.to_s+"_"+num.to_s) or page_num_array.include?([page,num])))

							page_num_array.push([page,num])
						end
					}
				end

				if (fill_gaps_flag and (page_num_array.length > 1))

					0.upto(page_num_array.length - 2) { |index|

						gap_page = page_num_array[index][0]
						gap_num = page_num_array[index][1]

						if ((gap_page == page_num_array[index + 1][0]))

							gap_num += offset_num

							# Fill any gaps between the box at index and the box at index + 1, as they are on the same page.
							# This will only work if the box numbers differ by the same offset.

							while (gap_num < page_num_array[index + 1][1])

								gap_box = "box"+gap_page.to_s+"_"+gap_num.to_s

								if (!(blank_array.include?(gap_box) or exclusion_box_array.include?(gap_box)))
									gap_array.push([gap_page,gap_num])
								end

								gap_num += offset_num
							end
						end
					}

					if (gap_array.length > 0)
						# Now concatenate the two arrays together and do a final sort.
						page_num_array = page_num_array.concat(gap_array)
						page_num_array.sort!
					end
				end
			end

			# Now put the box parts back together and append to box_str. box_str now holds all boxes that are not in
			# the exclusion array, not in the blank array, and are not duplicates - they came from the range of boxes
			# encapsulated in the code that is to be blanked, plus any boxes added per user request.
			page_num_array.each_index { |index|
				box_str += "box#{page_num_array[index][0]}_#{page_num_array[index][1]}"
			}
		else
			# We made sure that the first and last box arrays are the same length, so we can use index for both.
			first_box_array.each_index { |index|

				box = first_box_array[index]

				while process_box_range

					box_str += box unless (blank_array.include?(box) or exclusion_box_array.include?(box))
		
					# Increment box, quit loop when out of range.
					box = box.sub(/(_)(\d+)/) { |match|  $1 + $2.succ}
					process_box_range = (box.delete("^0-9").to_i <= last_box_array[index].delete("^0-9").to_i)
				end
				
				process_box_range = true
			}
		end

		box_str.gsub!(/(\d)(b)/, (blank_style == 2 ? '\1,\2' : '\1 + \2'))
	else
		custom_blank_str = custom_bar_text.get("1.0", "end")
		box_str = (custom_blank_str.strip.empty? ? "if ( )" : custom_blank_str)
	end

	# Now output the blanked code in the desired blanking style.
	case blank_style
		when 0
			# Bob style: if ((box1_1 + box1_4 + box1_9).strip.length > 0)......
			out_text.insert("end", "if ((#{box_str}).strip.length > 0)\n\n")
			code_array.each { |print_line| out_text.insert("end", "\t#{print_line}") }
			out_text.insert("end", "else\n")
			blank_array.each { |print_line| out_text.insert("end", "\t#{print_line} = ''\n") }
		when 1
			# April style: if( ( box1_1 + box1_4 + box1_9 ).strip.length == 0 )......
			out_text.insert("end", "if( ( #{box_str} ).strip.length == 0 )\n\n")
			blank_array.each { |print_line| out_text.insert("end", "\t#{print_line} = ''\n") }
			out_text.insert("end", "else\n")
			code_array.each { |print_line| out_text.insert("end", "\t#{print_line}") }
		when 2
			# Harry style: if (not_empty(box1_1,box1_4,box1_9))......
			out_text.insert("end", "if (not_empty(#{box_str}))\n\n")
			code_array.each { |print_line| out_text.insert("end", "\t#{print_line}") }
			out_text.insert("end", "else\n")
			blank_array.each { |print_line| out_text.insert("end", "\t#{print_line} = ''\n") }
		when 3
			# Custom style: if ( box1_1 < 100.0 )
			out_text.insert("end", "#{box_str}\n")
			code_array.each { |print_line| out_text.insert("end", "\t#{print_line}") }
			out_text.insert("end", "else\n")
			blank_array.each { |print_line| out_text.insert("end", "\t#{print_line} = ''\n") }
	end

	out_text.insert("end", "end\n\n")
	print_array.each { |print_line| out_text.insert("end", "#{print_line}\n") }
end

get_boxes_button.bind("Button-1") {

	page_num_array = Array.new
	box = String.new
	input_str = String.new

	# Clear the Box List.
	box_list.delete(0, box_list.index("end"))

	# Get input code.
	input_str = in_text.get("1.0", "end")

	input_str.each { |code_line|
		code_line.scan(/(box)(\d+)(_)(\d+)/) {
			page_num_array.push([$2.to_i,$4.to_i]) unless page_num_array.include?([$2.to_i,$4.to_i])
		}
	}

	# Now sort the two-dimensional page_num_array.
	page_num_array.sort!

	# Now put the box parts back together and insert into the Box List widget.
	page_num_array.each_index { |index|
		box_list.insert("end", "box#{page_num_array[index][0]}_#{page_num_array[index][1]}")
	}

	# Select (show highlighting) first list element.
	box_list.selection_set(0)
}

delete_box_list_button.bind("Button-1") { box_list.delete(0, box_list.index('end')) }

Tk.mainloop()
